#include <_EnumChildWindows.au3>
; ===============================================================================================================================
; <TestEnumChildWindows.au3>
;
;	Test for _EnumChildWindows UDF.
;
; Author: Ascend4nt
; ===============================================================================================================================

; ===================================================================================================================
;	TEST
; ===================================================================================================================

#include <Array.au3>

Local $hWnd="",$hControl=0,$sTitle=0,$sClass=0,$aEnumList
Local $iCalcPID,$hNumber1Button=-1,$hNumber4Button=-1,$hPlusButton=-1,$hEqualButton=-1
$iCalcPID=Run("calc.exe")
If @error Then Exit
$hWnd=WinWait("Calculator")

If $hWnd=0 Then Exit ProcessClose($iCalcPID)

; Important to wait for the window to fully 'create' itself before getting child windows!
; Note that other processes that become activated somewhere between WinWait and this will cause WinWaitActive() to wait for manual activation
;WinWaitActive($hWnd)	; bad idea in busy environment
WinActivate($hWnd)	; this seems to be a better alternative, the window seems fully created after this is called in my tests

; Parameters to function

;$hControl=HWnd(0x########)
;$sTitle="^(\d|\+|=)$"	; PCRE - gets controls with numbers, + or = sign only (problem: no instance #'s!)
;$sClass="Button"

$aEnumList=_EnumChildWindows($hWnd,$hControl,$sTitle,$sClass)	;,2) for RegExp Title
If @Error Then Exit ProcessClose($iCalcPID)

; Find specific items [Certain versions of Calc won't return any text]
For $i=1 to $aEnumList[0][0]
	Switch $aEnumList[$i][4]
		Case "1"
			$hNumber1Button=$aEnumList[$i][0]
			ConsoleWrite("'1' Advanced Mode Name (in current state): [CLASS:Button; INSTANCE:"&$aEnumList[$i][3]&"]"&@CRLF)
		Case "4"
			$hNumber4Button=$aEnumList[$i][0]
			ConsoleWrite("'4' Advanced Mode Name (in current state): [CLASS:Button; INSTANCE:"&$aEnumList[$i][3]&"]"&@CRLF)
		Case "+"
			$hPlusButton=$aEnumList[$i][0]
			ConsoleWrite("'+' Advanced Mode Name (in current state): [CLASS:Button; INSTANCE:"&$aEnumList[$i][3]&"]"&@CRLF)
		Case "="
			$hEqualButton=$aEnumList[$i][0]
			ConsoleWrite("'=' Advanced Mode Name (in current state): [CLASS:Button; INSTANCE:"&$aEnumList[$i][3]&"]"&@CRLF)
	EndSwitch
Next

; Add Headers
$aEnumList[0][0]="Handle"
$aEnumList[0][1]="Classname"
$aEnumList[0][2]="Control ID"
$aEnumList[0][3]="Iteration"
$aEnumList[0][4]="Title/Text"

; Bring the window forward
WinActivate($hWnd)

; Perform a simple calculation to show interaction
If $hNumber1Button<>-1 Then
	ControlClick($hWnd,"",$hNumber1Button,"primary",3)
	ControlClick($hWnd,"",$hNumber4Button)
	Sleep(1000)
	ControlClick($hWnd,"",$hPlusButton)
	Sleep(1000)
	ControlClick($hWnd,"",$hNumber4Button,"primary",2)	; double click, but that's fine
	Sleep(1000)
	ControlClick($hWnd,"",$hEqualButton)
EndIf

; And Display ALL Enumerated Windows
_ArrayDisplay($aEnumList,"Enumerated controls for 'Calculator'")
ProcessClose($iCalcPID)

